// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): SUNY Stony Brook students, Jonathan Berry

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#ifndef Permutation_h
#define Permutation_h

#include <iostream.h>
#include <math.h>
#include<LINK/basic/general.h>
#include<LINK/basic/Sequence.h>


class Permutation {
public:
       Permutation(int);
       Permutation(const Permutation&);
       Permutation(const Sequence<int>&);
       virtual ~Permutation()  {delete [] _permutation; }
       
       Permutation&      random();
       Permutation&      unrank(int);
       int               rank()   const;
       Permutation&      next();
       Permutation&      previous();
       Permutation&      first();
       Permutation&      last();
 
       ostream&          display(ostream& os)   const;
       Bool              operator==(const Permutation&) const;
       Bool              operator!=(const Permutation&) const;
       Bool              operator> (const Permutation&) const;
       Bool              operator< (const Permutation&) const;
       Bool              operator>=(const Permutation&) const;
       Bool              operator<=(const Permutation&) const;
       Bool              eq(const Permutation&) const;
       Bool              neq(const Permutation&) const;
       Bool              gt(const Permutation&) const;
       Bool              lt(const Permutation&) const;
       Bool              gte(const Permutation&) const;
       Bool              lte(const Permutation&) const;
       Permutation&      operator= (const Permutation&);
       //Permutation&      copy(const Permutation&);

       int               operator[] (int index) const;
       int               index(int index) const;
       
         int               size () const {return _length; }
       friend ostream&   operator<<(ostream&, const Permutation& );
private:
         int               _length;
         int*              _permutation;
         int*              _invers;
};

#endif
